package com.FranckBarbier.Java._Programmable_thermostat_GUI;

public class User_interface_JavaFX extends javafx.application.Application implements com.FranckBarbier.Java._Programmable_thermostat_MODEL._Programmable_thermostat.Programmable_thermostat_output {

    /**
     * MODEL
     */
    com.FranckBarbier.Java._Temperature.Temperature _ambient_temperature;
    com.FranckBarbier.Java._Programmable_thermostat_MODEL._Programmable_thermostat.Programmable_thermostat _programmable_thermostat;
    com.FranckBarbier.Java._Programmable_thermostat_MODEL._Programmable_thermostat.Temperature_sensor _temperature_sensor;

    /**
     * UI
     */
    private float _temp_down_temp_up_value = (com.FranckBarbier.Java._Programmable_thermostat_MODEL._Programmable_thermostat.Programmable_thermostat.Min(com.FranckBarbier.Java._Programmable_thermostat_MODEL._Programmable_thermostat.Programmable_thermostat.Default_temperature_mode) + com.FranckBarbier.Java._Programmable_thermostat_MODEL._Programmable_thermostat.Programmable_thermostat.Max(com.FranckBarbier.Java._Programmable_thermostat_MODEL._Programmable_thermostat.Programmable_thermostat.Default_temperature_mode)) / 2.F;

    /**
     * Slider management
     */
    private boolean _display_target_temperature = false;
    private boolean _display_program_target_temperature = false;
    private boolean _run_program_click = false;
    private boolean _view_program_click = false;

    private javafx.scene.control.Button _run_indicator = new javafx.scene.control.Button("\uD83D\uDCA4");
    private final javafx.scene.control.Label _target_temperature = new javafx.scene.control.Label();

    private final javafx.scene.control.Label ambientTemperatureView = new javafx.scene.control.Label("ambient temp.");
    private final javafx.scene.control.Label targetTemperatureView = new javafx.scene.control.Label("target temp.");
    private final javafx.scene.control.Label runIndicatorView = new javafx.scene.control.Label("Run indicator.Everything Off");
    private final javafx.scene.control.Label currentStateView = new javafx.scene.control.Label();
    private final javafx.scene.control.Label climateView = new javafx.scene.control.Label();
    private final javafx.scene.control.Label needle_status = new javafx.scene.control.Label();
    private final javafx.scene.control.Label houseView = new javafx.scene.control.Label();
    private final javafx.scene.control.Label mercuryView = new javafx.scene.control.Label();
    private final javafx.scene.control.Label dialView = new javafx.scene.control.Label();

    private final javafx.scene.control.Button fC = new javafx.scene.control.Button();
    private final javafx.scene.control.Button holdTemp = new javafx.scene.control.Button();
    private final javafx.scene.control.Button runProgram = new javafx.scene.control.Button();
    private final javafx.scene.control.Button setClock = new javafx.scene.control.Button();
    private final javafx.scene.control.Button setDay = new javafx.scene.control.Button();
    private final javafx.scene.control.Button timeForward = new javafx.scene.control.Button();
    private final javafx.scene.control.Button timeBackward = new javafx.scene.control.Button();
    private final javafx.scene.control.Button viewProgram = new javafx.scene.control.Button();

    private final javafx.scene.control.CheckBox Auto = new javafx.scene.control.CheckBox("Auto");
    private final javafx.scene.control.CheckBox On = new javafx.scene.control.CheckBox("On");

    private final javafx.scene.control.RadioButton Cool = new javafx.scene.control.RadioButton("Cool");
    private final javafx.scene.control.RadioButton Heat = new javafx.scene.control.RadioButton("Heat");
    private final javafx.scene.control.RadioButton Off = new javafx.scene.control.RadioButton("Off");

    private final javafx.scene.shape.Circle mercury_low = new javafx.scene.shape.Circle();
    private final javafx.scene.control.ProgressBar mercury_high = new javafx.scene.control.ProgressBar();

    private final javafx.scene.image.ImageView background = new javafx.scene.image.ImageView();

    javafx.scene.effect.DropShadow shadow = new javafx.scene.effect.DropShadow();
    private javafx.scene.control.Slider tempDownUp = new javafx.scene.control.Slider(com.FranckBarbier.Java._Programmable_thermostat_MODEL._Programmable_thermostat.Programmable_thermostat.Min(com.FranckBarbier.Java._Programmable_thermostat_MODEL._Programmable_thermostat.Programmable_thermostat.Default_temperature_mode), com.FranckBarbier.Java._Programmable_thermostat_MODEL._Programmable_thermostat.Programmable_thermostat.Max(com.FranckBarbier.Java._Programmable_thermostat_MODEL._Programmable_thermostat.Programmable_thermostat.Default_temperature_mode), _temp_down_temp_up_value);

    // Location: com.FranckBarbier.Java.images
    javafx.scene.image.Image background_image = new javafx.scene.image.Image("images/background.jpg");
    javafx.scene.image.Image sun_icon = new javafx.scene.image.Image("images/sun.png");
    javafx.scene.image.Image Franck = new javafx.scene.image.Image("images/Franck.jpg");
    javafx.scene.image.Image ice_icon = new javafx.scene.image.Image("images/ice.png");
    javafx.scene.image.Image cloudy_icon = new javafx.scene.image.Image("images/cloudy.png");
    javafx.scene.image.Image needle_icon = new javafx.scene.image.Image("images/needle.png");
    javafx.scene.image.Image mercury_icon = new javafx.scene.image.Image("images/mercury.png");
    javafx.scene.image.Image dial_icon = new javafx.scene.image.Image("images/dial.png");

    javafx.scene.image.Image celsius_image = new javafx.scene.image.Image("images/Celsius.png");
    javafx.scene.image.Image fahrenheit_image = new javafx.scene.image.Image("images/Fahrenheit.png");
    javafx.scene.image.Image hold_temp_image = new javafx.scene.image.Image("images/hold_temp.png");
    javafx.scene.image.Image run_program_image = new javafx.scene.image.Image("images/run_program.png");
    javafx.scene.image.Image set_clock_image = new javafx.scene.image.Image("images/set_clock.png");
    javafx.scene.image.Image set_day_image = new javafx.scene.image.Image("images/set_day.png");
    javafx.scene.image.Image time_backward_image = new javafx.scene.image.Image("images/time_backward.png");
    javafx.scene.image.Image time_forward_image = new javafx.scene.image.Image("images/time_forward.png");
    javafx.scene.image.Image view_program_image = new javafx.scene.image.Image("images/view_program.png");

    javafx.scene.image.Image house_icon = new javafx.scene.image.Image("images/house.png");

    @Override
    public void display_ambient_temperature(final String ambient_temperature, final com.FranckBarbier.Java._Temperature.Temperature at) {
        javafx.application.Platform.runLater(new Runnable() {
            @Override
            public void run() {
                if (at.asCelsius() <= 17.F) {
                    mercury_high.setStyle("-fx-accent:blue;");
                    mercury_low.setFill(javafx.scene.paint.Color.BLUE);
                    climateView.setGraphic(new javafx.scene.image.ImageView(ice_icon));
                } else if (at.asCelsius() > 17.F && at.asCelsius() <= 19.F) {
                    mercury_high.setStyle("-fx-accent:green;");
                    mercury_low.setFill(javafx.scene.paint.Color.GREEN);
                    climateView.setGraphic(new javafx.scene.image.ImageView(cloudy_icon));
                } else if (at.asCelsius() > 19.F && at.asCelsius() <= 21.F) {
                    mercury_high.setStyle("-fx-accent:orange;");
                    mercury_low.setFill(javafx.scene.paint.Color.ORANGE);
                    climateView.setGraphic(new javafx.scene.image.ImageView(sun_icon));
                } else {
                    mercury_high.setStyle("-fx-accent:red;");
                    mercury_low.setFill(javafx.scene.paint.Color.RED);
                    climateView.setGraphic(new javafx.scene.image.ImageView(sun_icon));
                }
                mercury_high.setProgress((at.asCelsius() / 100.F) + 0.17F);

                ambientTemperatureView.setText(ambient_temperature);
                ambientTemperatureView.setStyle("-fx-font:20px Cambria;" + "-fx-border-width:2;" + "-fx-border-color:black;");
                currentStateView.setText(_programmable_thermostat.async_current_state());
            }
        });
    }

    @Override
    public void display_current_date_and_time(final String current_date_and_time) {
        javafx.application.Platform.runLater(new Runnable() {
            @Override
            public void run() {
                ambientTemperatureView.setText(current_date_and_time);
                currentStateView.setText(_programmable_thermostat.async_current_state());
            }
        });
    }

    @Override
    public void display_period_and_program_time(final String period_and_program_time) {
        javafx.application.Platform.runLater(new Runnable() {
            @Override
            public void run() {
                ambientTemperatureView.setText(period_and_program_time);
                currentStateView.setText(_programmable_thermostat.async_current_state());
            }
        });
    }

    public void display_program_target_temperature(final com.FranckBarbier.Java._Temperature.Temperature target_temperature, final byte temperature_mode) {
        javafx.application.Platform.runLater(new Runnable() {
            @Override
            public void run() {
                if (temperature_mode == com.FranckBarbier.Java._Programmable_thermostat_MODEL._Programmable_thermostat.Programmable_thermostat.Default_temperature_mode) {
                    tempDownUp.setShowTickLabels(true);
                } else {
                    tempDownUp.setShowTickLabels(false);
                }
                switch (temperature_mode) {
                    case com.FranckBarbier.Java._Temperature.Temperature.Celsius:
                        targetTemperatureView.setText(target_temperature.asStringCelsius(1));
                        currentStateView.setText(_programmable_thermostat.async_current_state());
                        break;
                    case com.FranckBarbier.Java._Temperature.Temperature.Fahrenheit:
                        targetTemperatureView.setText(target_temperature.asStringFahrenheit(1));
                        currentStateView.setText(_programmable_thermostat.async_current_state());
                        break;
                    default:
                        System.err.println("User interface <display_program_target_temperature> failure: non existing temperature mode");
                        System.exit(1);
                }
                switch (com.FranckBarbier.Java._Programmable_thermostat_MODEL._Programmable_thermostat.Programmable_thermostat.Default_temperature_mode) {
                    case com.FranckBarbier.Java._Temperature.Temperature.Celsius:
                        _temp_down_temp_up_value = target_temperature.asCelsius();
                        if (_display_target_temperature || _view_program_click) {
                            tempDownUp.setValue(_temp_down_temp_up_value);
                            _display_target_temperature = false;
                        }
                        break;
                    case com.FranckBarbier.Java._Temperature.Temperature.Fahrenheit:
                        _temp_down_temp_up_value = target_temperature.asFahrenheit();
                        if (_display_target_temperature || _view_program_click) {
                            tempDownUp.setValue(_temp_down_temp_up_value);
                            _display_target_temperature = false;
                        }
                        break;
                    default:
                        System.err.println("User interface <display_program_target_temperature> failure: non existing temperature mode");
                        System.exit(1);
                }
            }
        }
        );
        _display_program_target_temperature = true;
    }

    public void display_target_temperature(final com.FranckBarbier.Java._Temperature.Temperature target_temperature, final byte temperature_mode) {
        javafx.application.Platform.runLater(new Runnable() {
            @Override
            public void run() {
                if (temperature_mode == com.FranckBarbier.Java._Programmable_thermostat_MODEL._Programmable_thermostat.Programmable_thermostat.Default_temperature_mode) {
                    tempDownUp.setShowTickLabels(true);
                } else {
                    tempDownUp.setShowTickLabels(false);
                }
                switch (temperature_mode) {
                    case com.FranckBarbier.Java._Temperature.Temperature.Celsius:
                        targetTemperatureView.setText(target_temperature.asStringCelsius(1));
                        currentStateView.setText(_programmable_thermostat.async_current_state());
                        fC.setGraphic(new javafx.scene.image.ImageView(fahrenheit_image));
                        break;
                    case com.FranckBarbier.Java._Temperature.Temperature.Fahrenheit:
                        targetTemperatureView.setText(target_temperature.asStringFahrenheit(1));
                        currentStateView.setText(_programmable_thermostat.async_current_state());
                        fC.setGraphic(new javafx.scene.image.ImageView(celsius_image));
                        break;
                    default:
                        System.err.println("User interface <display_target_temperature> failure: non existing temperature mode");
                        System.exit(1);
                }
                switch (com.FranckBarbier.Java._Programmable_thermostat_MODEL._Programmable_thermostat.Programmable_thermostat.Default_temperature_mode) {
                    case com.FranckBarbier.Java._Temperature.Temperature.Celsius:
                        _temp_down_temp_up_value = target_temperature.asCelsius();
                        if (_display_program_target_temperature || _run_program_click) {
                            tempDownUp.setValue(_temp_down_temp_up_value);
                            _display_program_target_temperature = false;
                        }
                        break;
                    case com.FranckBarbier.Java._Temperature.Temperature.Fahrenheit:
                        _temp_down_temp_up_value = target_temperature.asFahrenheit();
                        if (_display_program_target_temperature || _run_program_click) {
                            tempDownUp.setValue(_temp_down_temp_up_value);
                            _display_program_target_temperature = false;
                        }
                        break;
                    default:
                        System.err.println("User interface <display_target_temperature> failure: non existing temperature mode");
                        System.exit(1);
                }
            }
        }
        );
        _display_target_temperature = true;
    }

    @Override
    public void update_run_indicator_status(final String run_indicator_status) {
        javafx.application.Platform.runLater(new Runnable() {
            @Override
            public void run() {
                if (run_indicator_status.contains(com.FranckBarbier.Java._Programmable_thermostat_MODEL._Programmable_thermostat.Run_indicator.Everything_off)) {
                    _run_indicator.setText("\uD83D\uDCA4");
                    _run_indicator.setStyle("-fx-base: green;");
                    currentStateView.setText(_programmable_thermostat.async_current_state());
                } else {
                    _run_indicator.setText(String.valueOf('\u26A1'));
                    if (_programmable_thermostat.furnace_relay_is_on()) {
                        _run_indicator.setStyle("-fx-base: red;");
                    }
                    if (_programmable_thermostat.air_conditioner_relay_is_on()) {
                        _run_indicator.setStyle("-fx-base: blue;");
                    }
                    currentStateView.setText(_programmable_thermostat.async_current_state());
                }
            }
        });

    }

    @Override
    public void start(javafx.stage.Stage primaryStage) {
        try {
            _ambient_temperature = new com.FranckBarbier.Java._Temperature.Temperature(18.F, com.FranckBarbier.Java._Temperature.Temperature.Celsius, (float) 1.E-2);
            _programmable_thermostat = new com.FranckBarbier.Java._Programmable_thermostat_MODEL._Programmable_thermostat.Programmable_thermostat(_ambient_temperature);
            _temperature_sensor = new com.FranckBarbier.Java._Programmable_thermostat_MODEL._Programmable_thermostat.Temperature_sensor(_programmable_thermostat, _ambient_temperature);
        } catch (Throwable t) {
            System.err.println("User interface <programmable thermostat initialization> failure: " + t.getMessage());
            System.exit(1);
        }

        fC.setCursor(javafx.scene.Cursor.HAND);
        fC.setGraphic(new javafx.scene.image.ImageView(celsius_image));
        fC.setTooltip(new javafx.scene.control.Tooltip("Convert Fahrenheit to Celsius or convert Celsius to Fahrenheit"));
        holdTemp.setCursor(javafx.scene.Cursor.HAND);
        holdTemp.setGraphic(new javafx.scene.image.ImageView(hold_temp_image));
        holdTemp.setTooltip(new javafx.scene.control.Tooltip("Hold temp - Do not perform control program"));
        runProgram.setCursor(javafx.scene.Cursor.HAND);
        runProgram.setGraphic(new javafx.scene.image.ImageView(run_program_image));
        runProgram.setTooltip(new javafx.scene.control.Tooltip("Run program - Perform control program"));
        setClock.setCursor(javafx.scene.Cursor.HAND);
        setClock.setGraphic(new javafx.scene.image.ImageView(set_clock_image));
        setClock.setTooltip(new javafx.scene.control.Tooltip("Set clock"));
        setDay.setCursor(javafx.scene.Cursor.HAND);
        setDay.setGraphic(new javafx.scene.image.ImageView(set_day_image));
        setDay.setTooltip(new javafx.scene.control.Tooltip("Set day"));
        timeBackward.setGraphic(new javafx.scene.image.ImageView(time_backward_image));
        timeBackward.setCursor(javafx.scene.Cursor.HAND);
        timeBackward.setTooltip(new javafx.scene.control.Tooltip("Time backward"));
        timeForward.setCursor(javafx.scene.Cursor.HAND);
        timeForward.setGraphic(new javafx.scene.image.ImageView(time_forward_image));
        timeForward.setTooltip(new javafx.scene.control.Tooltip("Time forward"));
        viewProgram.setCursor(javafx.scene.Cursor.CLOSED_HAND);
        viewProgram.setGraphic(new javafx.scene.image.ImageView(view_program_image));
        viewProgram.setTooltip(new javafx.scene.control.Tooltip("View program"));

        Off.setSelected(true);
        On.setText("On");
        Auto.setText("Auto");
        Auto.setSelected(true);
        Auto.setStyle("-fx-color:green;");

        _run_indicator.setStyle("-fx-base: green;");
        _run_indicator.setTranslateX(0);
        _run_indicator.setTranslateY(315);
        _target_temperature.setPrefSize(Double.MAX_VALUE, Double.MAX_VALUE);
        _target_temperature.setAlignment(javafx.geometry.Pos.CENTER);

        mercury_low.setTranslateX(-470);
        mercury_low.setTranslateY(62);
        mercury_low.setRadius(18.0f);
        mercury_low.setScaleX(0.9);
        mercury_low.setScaleY(0.9);
        mercury_low.setFill(javafx.scene.paint.Color.WHITE);
        mercury_high.setRotate(270);
        mercury_high.setTranslateX(-470);
        mercury_high.setTranslateY(-30);
        mercury_high.setPrefSize(170, 2);
        mercury_high.setProgress(0.5f);
        mercury_high.setStyle("-fx-accent:white;");

        /**
         * Layout
         */
        fC.setTranslateX(-425);
        fC.setTranslateY(-210);
        fC.setPrefSize(134, 70);
        holdTemp.setTranslateX(425);
        holdTemp.setTranslateY(-210);
        holdTemp.setPrefSize(134, 70);
        runProgram.setTranslateX(0);
        runProgram.setTranslateY(-290);
        runProgram.setPrefSize(980, 70);
        setClock.setTranslateX(-300);
        setClock.setTranslateY(110);
        setClock.setPrefSize(150, 80);
        setDay.setTranslateX(-300);
        setDay.setTranslateY(192);
        setDay.setPrefSize(150, 80);
        timeBackward.setTranslateX(350);
        timeBackward.setTranslateY(192);
        timeBackward.setPrefSize(150, 80);
        timeForward.setTranslateX(350);
        timeForward.setTranslateY(275);
        timeForward.setPrefSize(150, 80);
        viewProgram.setTranslateX(-300);
        viewProgram.setTranslateY(275);
        viewProgram.setPrefSize(150, 80);

        Cool.setTranslateX(-470);
        Cool.setTranslateY(111);
        Heat.setTranslateX(-470);
        Heat.setTranslateY(151);
        Off.setTranslateX(-475);
        Off.setTranslateY(195);

        Auto.setTranslateX(460);
        Auto.setTranslateY(195);
        On.setTranslateX(460);
        On.setTranslateY(270);

        tempDownUp.setTranslateX(0);
        tempDownUp.setTranslateY(-150);
        tempDownUp.setPrefSize(650, 37);
        tempDownUp.setStyle("");
        tempDownUp.setMajorTickUnit(com.FranckBarbier.Java._Programmable_thermostat_MODEL._Programmable_thermostat.Programmable_thermostat.Target_temperature_precision);
        tempDownUp.setMinorTickCount(0);
        tempDownUp.setBlockIncrement(com.FranckBarbier.Java._Programmable_thermostat_MODEL._Programmable_thermostat.Programmable_thermostat.Target_temperature_precision);
        tempDownUp.setShowTickMarks(true);

        background.setImage(background_image);

        ambientTemperatureView.setTranslateX(0);
        ambientTemperatureView.setTranslateY(0);
        ambientTemperatureView.setStyle("-fx-font:20px Cambria;" + "-fx-border-width:2;" + "-fx-border-color:black;");
        climateView.setTranslateX(-400);
        climateView.setTranslateY(60);
        climateView.setGraphic(new javafx.scene.image.ImageView(Franck));
        currentStateView.setTranslateX(0);
        currentStateView.setTranslateY(335);
        currentStateView.setAlignment(javafx.geometry.Pos.CENTER);
        currentStateView.setPrefSize(Double.MAX_VALUE, Double.MAX_VALUE);
        currentStateView.setFont(javafx.scene.text.Font.font(10));
        dialView.setTranslateX(0);
        dialView.setTranslateY(-70);
        dialView.setGraphic(new javafx.scene.image.ImageView(dial_icon));
        houseView.setGraphic(new javafx.scene.image.ImageView(house_icon));
        houseView.setTranslateX(0);
        houseView.setTranslateY(90);
        mercuryView.setTranslateX(-470);
        mercuryView.setTranslateY(-30);
        mercuryView.setGraphic(new javafx.scene.image.ImageView(mercury_icon));
        runIndicatorView.setTranslateX(0);
        runIndicatorView.setTranslateY(250);
        targetTemperatureView.setStyle("-fx-font:14px Cambria;");
        targetTemperatureView.setTranslateX(0);
        targetTemperatureView.setTranslateY(-180);

        needle_status.setTranslateX(-2);
        needle_status.setTranslateY(-70);
        needle_status.setRotate(50);
        needle_status.setGraphic(new javafx.scene.image.ImageView(needle_icon));

        javafx.scene.layout.StackPane root = new javafx.scene.layout.StackPane();

        root.getChildren().add(background);
        root.getChildren().add(currentStateView);
        root.getChildren().add(timeBackward);
        root.getChildren().add(timeForward);
        root.getChildren().add(Auto);
        root.getChildren().add(On);
        root.getChildren().add(setClock);
        root.getChildren().add(setDay);
        root.getChildren().add(viewProgram);
        root.getChildren().add(Cool);
        root.getChildren().add(Heat);
        root.getChildren().add(Off);
        root.getChildren().add(runProgram);
        root.getChildren().add(fC);
        root.getChildren().add(holdTemp);
        root.getChildren().add(tempDownUp);
        root.getChildren().add(targetTemperatureView);
        root.getChildren().add(ambientTemperatureView);
        root.getChildren().add(_run_indicator);
        root.getChildren().add(mercury_high);
        root.getChildren().add(mercury_low);
        root.getChildren().add(dialView);
        root.getChildren().add(mercuryView);
        root.getChildren().add(climateView);
        root.getChildren().add(needle_status);
        root.getChildren().add(houseView);

        javafx.scene.Scene scene = new javafx.scene.Scene(root, 1000, 700);

        primaryStage.setTitle("Programmable thermostat (Northern hemisphere only!)");
        primaryStage.setScene(scene);
        primaryStage.show();

        _programmable_thermostat.add_user_interface(this);
        try {
            _programmable_thermostat.start();
            _temperature_sensor.start();
        } catch (Throwable t) {
            System.err.println("User interface <programmable thermostat startup> failure: " + t.getMessage());
            System.exit(1);
        }

        /**
         * Effects
         */
        Auto.setOnAction(new javafx.event.EventHandler<javafx.event.ActionEvent>() {
            @Override
            public void handle(javafx.event.ActionEvent event) {
                try {
                    if (_programmable_thermostat != null) {
                        _programmable_thermostat.fan_switch_auto();
                        autoSetActive();
                        onSetNotActive();
                    }
                } catch (Exception e) {
                    System.err.println("User interface <fan_switch_auto> failure: " + e.getMessage());
                    System.exit(1);
                }
            }
        });
        On.setOnAction(new javafx.event.EventHandler<javafx.event.ActionEvent>() {
            @Override
            public void handle(javafx.event.ActionEvent event) {

                try {
                    if (_programmable_thermostat != null) {
                        _programmable_thermostat.fan_switch_on();
                        onSetActive();
                        autoSetNotActive();
                    }
                } catch (Exception e) {
                    System.err.println("User interface <fan_switch_on> failure: " + e.getMessage());
                    System.exit(1);
                }
            }
        });
        fC.addEventHandler(javafx.scene.input.MouseEvent.MOUSE_ENTERED,
                new javafx.event.EventHandler<javafx.scene.input.MouseEvent>() {
                    @Override
                    public void handle(javafx.scene.input.MouseEvent e) {
                        fC.setEffect(shadow);
                    }
                });
        fC.addEventHandler(javafx.scene.input.MouseEvent.MOUSE_EXITED,
                new javafx.event.EventHandler<javafx.scene.input.MouseEvent>() {
                    @Override
                    public void handle(javafx.scene.input.MouseEvent e) {
                        fC.setEffect(null);
                    }
                });
        fC.setOnAction(new javafx.event.EventHandler<javafx.event.ActionEvent>() {
            @Override
            public void handle(javafx.event.ActionEvent event) {
                try {
                    if (_programmable_thermostat != null) {
                        _programmable_thermostat.f_c();
                    }
                } catch (Exception e) {
                    System.err.println("User interface <f_c> failure: " + e.getMessage());
                    System.exit(1);
                }
            }
        });
        holdTemp.addEventHandler(javafx.scene.input.MouseEvent.MOUSE_ENTERED,
                new javafx.event.EventHandler<javafx.scene.input.MouseEvent>() {
                    @Override
                    public void handle(javafx.scene.input.MouseEvent e) {
                        holdTemp.setEffect(shadow);
                    }
                });
        holdTemp.addEventHandler(javafx.scene.input.MouseEvent.MOUSE_EXITED,
                new javafx.event.EventHandler<javafx.scene.input.MouseEvent>() {
                    @Override
                    public void handle(javafx.scene.input.MouseEvent e) {
                        holdTemp.setEffect(null);
                    }
                });
        holdTemp.setOnAction(new javafx.event.EventHandler<javafx.event.ActionEvent>() {
            @Override
            public void handle(javafx.event.ActionEvent event) {
                try {
                    if (_programmable_thermostat != null) {
                        _programmable_thermostat.hold_temp();
                    }
                } catch (Exception e) {
                    System.err.println("User interface <hold_temp> failure: " + e.getMessage());
                    System.exit(1);
                }
            }
        });
        runProgram.addEventHandler(javafx.scene.input.MouseEvent.MOUSE_ENTERED,
                new javafx.event.EventHandler<javafx.scene.input.MouseEvent>() {
                    @Override
                    public void handle(javafx.scene.input.MouseEvent e) {
                        runProgram.setEffect(shadow);
                    }
                });
        runProgram.addEventHandler(javafx.scene.input.MouseEvent.MOUSE_EXITED,
                new javafx.event.EventHandler<javafx.scene.input.MouseEvent>() {
                    @Override
                    public void handle(javafx.scene.input.MouseEvent e) {
                        runProgram.setEffect(null);
                    }
                });
        runProgram.setOnAction(new javafx.event.EventHandler<javafx.event.ActionEvent>() {
            @Override
            public void handle(javafx.event.ActionEvent event) {
                try {
                    if (_programmable_thermostat != null) {
                        _run_program_click = true;
                        _programmable_thermostat.run_program();
                        clockSetNotActive();
                        daySetNotActive();
                        viewProgramSetNotActive();
                    }
                } catch (Exception e) {
                    System.err.println("User interface <run_program> failure: " + e.getMessage());
                    System.exit(1);
                }
            }
        });
        setClock.addEventHandler(javafx.scene.input.MouseEvent.MOUSE_ENTERED,
                new javafx.event.EventHandler<javafx.scene.input.MouseEvent>() {
                    @Override
                    public void handle(javafx.scene.input.MouseEvent e) {
                        setClock.setEffect(shadow);
                    }
                });
        setClock.addEventHandler(javafx.scene.input.MouseEvent.MOUSE_EXITED,
                new javafx.event.EventHandler<javafx.scene.input.MouseEvent>() {
                    @Override
                    public void handle(javafx.scene.input.MouseEvent e) {
                        setClock.setEffect(null);
                    }
                });
        setClock.setOnAction(new javafx.event.EventHandler<javafx.event.ActionEvent>() {
            @Override
            public void handle(javafx.event.ActionEvent event) {
                try {
                    if (_programmable_thermostat != null) {
                        _programmable_thermostat.set_clock();
                        clockSetActive();
                        daySetNotActive();
                        viewProgramSetNotActive();
                    }
                } catch (Exception e) {
                    System.err.println("User interface <set_clock> failure: " + e.getMessage());
                    System.exit(1);
                }
            }
        });
        setDay.addEventHandler(javafx.scene.input.MouseEvent.MOUSE_ENTERED,
                new javafx.event.EventHandler<javafx.scene.input.MouseEvent>() {
                    @Override
                    public void handle(javafx.scene.input.MouseEvent e) {
                        setDay.setEffect(shadow);
                    }
                });
        setDay.addEventHandler(javafx.scene.input.MouseEvent.MOUSE_EXITED,
                new javafx.event.EventHandler<javafx.scene.input.MouseEvent>() {
                    @Override
                    public void handle(javafx.scene.input.MouseEvent e) {
                        setDay.setEffect(null);
                    }
                });
        setDay.setOnAction(new javafx.event.EventHandler<javafx.event.ActionEvent>() {
            @Override
            public void handle(javafx.event.ActionEvent event) {
                try {
                    if (_programmable_thermostat != null) {
                        _programmable_thermostat.set_day();
                        daySetActive();
                        clockSetNotActive();
                        viewProgramSetNotActive();
                    }
                } catch (Exception e) {
                    System.err.println("User interface <set_day> failure: " + e.getMessage());
                    System.exit(1);
                }
            }
        });
        timeBackward.addEventHandler(javafx.scene.input.MouseEvent.MOUSE_ENTERED,
                new javafx.event.EventHandler<javafx.scene.input.MouseEvent>() {
                    @Override
                    public void handle(javafx.scene.input.MouseEvent e) {
                        timeBackward.setEffect(shadow);
                    }
                });
        timeBackward.addEventHandler(javafx.scene.input.MouseEvent.MOUSE_EXITED,
                new javafx.event.EventHandler<javafx.scene.input.MouseEvent>() {
                    @Override
                    public void handle(javafx.scene.input.MouseEvent e) {
                        timeBackward.setEffect(null);
                    }
                });
        timeBackward.setOnAction(new javafx.event.EventHandler<javafx.event.ActionEvent>() {
            @Override
            public void handle(javafx.event.ActionEvent event) {
                try {
                    if (_programmable_thermostat != null) {
                        _programmable_thermostat.time_backward();
                    }
                } catch (Exception e) {
                    System.err.println("User interface <time_backward> failure: " + e.getMessage());
                    System.exit(1);
                }
            }
        });
        timeForward.addEventHandler(javafx.scene.input.MouseEvent.MOUSE_ENTERED,
                new javafx.event.EventHandler<javafx.scene.input.MouseEvent>() {
                    @Override
                    public void handle(javafx.scene.input.MouseEvent e) {
                        timeForward.setEffect(shadow);
                    }
                });

        timeForward.addEventHandler(javafx.scene.input.MouseEvent.MOUSE_EXITED,
                new javafx.event.EventHandler<javafx.scene.input.MouseEvent>() {
                    @Override
                    public void handle(javafx.scene.input.MouseEvent e) {
                        timeForward.setEffect(null);
                    }
                });
        timeForward.setOnAction(new javafx.event.EventHandler<javafx.event.ActionEvent>() {
            @Override
            public void handle(javafx.event.ActionEvent event) {
                try {
                    if (_programmable_thermostat != null) {
                        _programmable_thermostat.time_forward();
                    }
                } catch (Exception e) {
                    System.err.println("User interface <time_forward> failure: " + e.getMessage());
                    System.exit(1);
                }
            }
        });
        viewProgram.addEventHandler(javafx.scene.input.MouseEvent.MOUSE_ENTERED,
                new javafx.event.EventHandler<javafx.scene.input.MouseEvent>() {
                    @Override
                    public void handle(javafx.scene.input.MouseEvent e) {
                        viewProgram.setEffect(shadow);
                    }
                });
        viewProgram.addEventHandler(javafx.scene.input.MouseEvent.MOUSE_EXITED,
                new javafx.event.EventHandler<javafx.scene.input.MouseEvent>() {
                    @Override
                    public void handle(javafx.scene.input.MouseEvent e) {
                        viewProgram.setEffect(null);
                    }
                });
        viewProgram.setOnAction(new javafx.event.EventHandler<javafx.event.ActionEvent>() {
            @Override
            public void handle(javafx.event.ActionEvent event) {
                try {
                    if (_programmable_thermostat != null) {
                        _programmable_thermostat.view_program();
                        viewProgramSetActive();
                        clockSetNotActive();
                        daySetNotActive();
                        tempDownUp.setValue(21);
                    }
                } catch (Exception e) {
                    System.err.println("User interface <view_program> failure: " + e.getMessage());
                    System.exit(1);
                }
            }
        });
        Cool.setOnAction(new javafx.event.EventHandler<javafx.event.ActionEvent>() {
            @Override
            public void handle(javafx.event.ActionEvent event) {
                try {
                    if (_programmable_thermostat != null) {
                        _programmable_thermostat.season_switch_cool();
                        coolSetActive();
                        heatSetNotActive();
                        offSetNotActive();
                    }
                } catch (Exception e) {
                    System.err.println("User interface <season_switch_cool> failure: " + e.getMessage());
                    System.exit(1);
                }
            }
        });
        Heat.setOnAction(new javafx.event.EventHandler<javafx.event.ActionEvent>() {
            @Override
            public void handle(javafx.event.ActionEvent event) {
                try {
                    if (_programmable_thermostat != null) {
                        _programmable_thermostat.season_switch_heat();
                        heatSetActive();
                        coolSetNotActive();
                        offSetNotActive();
                    }
                } catch (Exception e) {
                    System.err.println("User interface <season_switch_heat> failure: " + e.getMessage());
                    System.exit(1);
                }
            }
        });
        Off.setOnAction(new javafx.event.EventHandler<javafx.event.ActionEvent>() {
            @Override
            public void handle(javafx.event.ActionEvent event) {
                try {
                    if (_programmable_thermostat != null) {
                        _programmable_thermostat.season_switch_off();
                        offSetActive();
                        heatSetNotActive();
                        coolSetNotActive();
                    }
                } catch (Exception e) {
                    System.err.println("User interface <season_switch_off> failure: " + e.getMessage());
                    System.exit(1);
                }
            }
        });
        tempDownUp.valueProperty().addListener(new javafx.beans.value.ChangeListener<Number>() {
            @Override
            public void changed(javafx.beans.value.ObservableValue<? extends Number> observable, Number old_value, Number new_value) {
                try {
                    if (_temp_down_temp_up_value > new_value.floatValue()) {
                        for (int i = 0; i < Math.round((_temp_down_temp_up_value - new_value.floatValue()) / com.FranckBarbier.Java._Programmable_thermostat_MODEL._Programmable_thermostat.Programmable_thermostat.Target_temperature_precision); i++) {
                            _programmable_thermostat.temp_down();
                            _run_program_click = false;
                            _view_program_click = false;
                            needle_status.setRotate(needle_status.getRotate() - 9);
                        }
                    }
                    if (_temp_down_temp_up_value < new_value.floatValue()) {
                        for (int i = 0; i < Math.round((new_value.floatValue() - _temp_down_temp_up_value) / com.FranckBarbier.Java._Programmable_thermostat_MODEL._Programmable_thermostat.Programmable_thermostat.Target_temperature_precision); i++) {
                            _programmable_thermostat.temp_up();
                            _run_program_click = false;
                            _view_program_click = false;
                            needle_status.setRotate(needle_status.getRotate() + 9);
                        }
                    }
                } catch (Exception e) {
                    System.err.println("User interface <temp_down/temp_up> failure: " + e.getMessage());
                    System.exit(1);
                }
            }
        });

        primaryStage.setOnCloseRequest(new javafx.event.EventHandler<javafx.stage.WindowEvent>() {
            @Override
            public void handle(javafx.stage.WindowEvent event) {
                try {
                    _temperature_sensor.stop();
                    _programmable_thermostat.stop();
                    javafx.application.Platform.exit();
                    System.exit(0);
                } catch (Throwable t) {
                    System.err.println("User interface <programmable thermostat finalization> failure: " + t.getMessage());
                    System.exit(1);
                }
            }
        });
    }

    void clockSetActive() {
        setClock.setStyle("-fx-color:lightgray;");
    }

    void clockSetNotActive() {
        setClock.setStyle("-fx-color:;");
    }

    void viewProgramSetActive() {
        viewProgram.setStyle("-fx-color:lightgray;");
    }

    void viewProgramSetNotActive() {
        viewProgram.setStyle("-fx-color:;");
    }

    void daySetActive() {
        setDay.setStyle("-fx-color:lightgray;");
    }

    void daySetNotActive() {
        setDay.setStyle("-fx-color:;");
    }

    void heatSetActive() {
        Heat.setStyle("-fx-color:red;");
        Heat.setSelected(true);
    }

    void heatSetNotActive() {
        Heat.setSelected(false);
        Heat.setStyle("-fx-color:;");
    }

    void coolSetActive() {
        Cool.setStyle("-fx-color:blue;");
        Cool.setSelected(true);
    }

    void coolSetNotActive() {
        Cool.setSelected(false);
        Cool.setStyle("-fx-color:;");
    }

    void offSetActive() {
        Off.setSelected(true);
    }

    void offSetNotActive() {
        Off.setSelected(false);
    }

    void autoSetActive() {
        Auto.setStyle("-fx-color:green;");
        Auto.setSelected(true);
    }

    void autoSetNotActive() {
        Auto.setSelected(false);
        Auto.setStyle("-fx-color:;");
    }

    void onSetActive() {
        On.setStyle("-fx-color:green;");
        On.setSelected(true);
    }

    void onSetNotActive() {
        On.setSelected(false);
        On.setStyle("-fx-color:;");
    }

    public static void main(String[] args) {
        launch(args);
    }
}
